diff --git a/test/f90_correct/inc/use01.mk b/test/f90_correct/inc/use01.mk
new file mode 100644
index 000000000000..db089b6052c0
--- /dev/null
+++ b/test/f90_correct/inc/use01.mk
@@ -0,0 +1,22 @@
+#
+# Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
+# See https://llvm.org/LICENSE.txt for license information.
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+#
+
+$(TEST): run
+
+
+build:  $(SRC)/$(TEST).f90
+	-$(RM) $(TEST).$(EXESUFFIX) core *.d *.mod FOR*.DAT FTN* ftn* fort.*
+	@echo ------------------------------------ building test $@
+	-$(FC) -c $(FFLAGS) $(LDFLAGS) $(SRC)/$(TEST).f90 -o $(TEST).$(OBJX)
+	-$(FC) $(FFLAGS) $(LDFLAGS) $(TEST).$(OBJX) $(LIBS) -o $(TEST).$(EXESUFFIX)
+
+
+run:
+	@echo ------------------------------------ executing test $(TEST)
+	$(TEST).$(EXESUFFIX)
+
+verify: ;
+
diff --git a/test/f90_correct/lit/use01.sh b/test/f90_correct/lit/use01.sh
new file mode 100644
index 000000000000..33c953a156b4
--- /dev/null
+++ b/test/f90_correct/lit/use01.sh
@@ -0,0 +1,9 @@
+#
+# Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
+# See https://llvm.org/LICENSE.txt for license information.
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+
+# Shared lit script for each tests. Run bash commands that run tests with make.
+
+# RUN: KEEP_FILES=%keep FLAGS=%flags TEST_SRC=%s MAKE_FILE_DIR=%S/.. bash %S/runmake | tee %t 
+# RUN: cat %t | FileCheck %S/runmake
diff --git a/test/f90_correct/src/use01.f90 b/test/f90_correct/src/use01.f90
new file mode 100644
index 000000000000..0f46405acd2e
--- /dev/null
+++ b/test/f90_correct/src/use01.f90
@@ -0,0 +1,30 @@
+! Code based on the reproducer from https://github.com/flang-compiler/flang/issues/1146
+
+module public1
+  integer, public :: var = 1
+  integer, public :: var1 = 11
+end module
+
+module public2
+  integer, public :: var = 2
+end module
+
+module use_public2
+  use public2, only : var
+  private
+end module
+
+program use_1_2
+  use public1, only : var1
+  use use_public2
+  integer :: ret = 0
+  ret = foo()
+  if (ret /= 1) STOP 1
+  print *, "PASS"
+contains
+  function foo() result(ret)
+    use public1, only : var
+    integer :: ret
+    ret = var
+  end function
+end program
diff --git a/tools/flang1/flang1exe/module.c b/tools/flang1/flang1exe/module.c
index 9958a6300e75..8a671bdf380a 100644
--- a/tools/flang1/flang1exe/module.c
+++ b/tools/flang1/flang1exe/module.c
@@ -313,14 +313,16 @@ add_use_rename(SPTR local, SPTR global, LOGICAL is_operator)
   if (STYPEG(global) == ST_ALIAS && PRIVATEG(global) &&
       SCOPEG(global) != curr_scope()->sptr) {
     /* global is an alias from another scope, generate an alias for the
-     * current scope */
+     * current scope if exist rename, or generate a fake symbol if not.
+     */
     SPTR newglobal = insert_sym(global);
     pr->global = newglobal;
     pr->local = local;
     SCOPEP(newglobal, curr_scope()->sptr);
     ENCLFUNCP(newglobal, SCOPEG(newglobal));
     DTYPEP(newglobal, DTYPEG(global));
-    STYPEP(newglobal, ST_ALIAS);
+    if (pr->local)
+      STYPEP(newglobal, ST_ALIAS);
     SYMLKP(newglobal, SYMLKG(global));
     HIDDENP(SYMLKG(newglobal), 0);
     pr->lineno = gbl.lineno;
